/**
 * @file  bidiLib.h
 * @brief Header file of Bi-di Lib module API
 *
 * @date 2004/02/12
 * @version 1.0.0
 *
 * Copyright (c) 2002-2004, BBR Co.Ltd., All rights reserved.
 */
/*
 * Permission is hereby granted, free of charge, to any person obtaining
 * a copy of this software and associated documentation files (the
 * "Software"), to deal in the Software without restriction, including
 * without limitation the rights to use, copy, modify, merge, publish,
 * distribute, sublicense, and/or sell copies of the Software, and to
 * permit persons to whom the Software is furnished to do so, subject to
 * the following conditions:
 *
 * The above copyright notice and this permission notice shall be included
 * in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
 * IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
 * CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
 * TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 * SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */

#ifndef _BIDILIB_H
#define _BIDILIB_H

/* definitions of constants */
// buffer size
/** XMLϥХåե */
#define XML_BUFFER_SIZE 11000
/** ץ̾θʸ */
#define PRINTER_NAME    "PIXUS850I"


/* type definitions */
/** ͭ饤֥꥿פBi-di Object */
typedef struct {
    int fdRead;         /**< readfile descriptor */
    int fdWrite;        /**< writefile descriptor */
    char *uri;          /**< ץURIʸ */
    int isPrinterUp;    /**< ץ󥿤֤ˤʤäȤ򼨤ե饰 */
    int idJob;	        /**< idJob򵭲 */
    char xmlBuf[XML_BUFFER_SIZE];   /**< XMLѤΥХåե */
    int xmlSize;        /**< ХåեXMLΥХȥ */
    int pXmlBuf;        /**< ХåեXMLνѥݥ */
} BidiLibC;


/* declarations of Bidi Plug-in Internal APIs for Shared Lib Type  */
void *bidiLibNew(int fdRead, int fdWrite, char *pURI);

void bidiLibDestroy(void *pBidiLibC);

int bidiLibGetCap(void *pBidiLibC, BidiCap cap);

int bidiLibStartJob(void *pBidiLibC, int idJob);

int bidiLibEndJob(void *pBidiLibC);

int bidiLibCancelJob(void *pBidiLibC, int idJob);

int bidiLibGetReadFD(void *pBidiLibC);

int bidiLibStartRead(void *pBidiLibC, BidiReadMode idReadMode, char *pLang);

int bidiLibRead(void *pBidiLibC, void *pBuf, int nBufBytes);

int bidiLibEndRead(void *pBidiLibC);

int bidiLibGetWriteFD(void *pBidiLibC);

//int bidiLibStartWrite(void *pBidiLibC);

//int bidiLibWrite(void *pBidiLibC, void *pBuf, int nBufBytes);

//int bidiLibEndWrite(void *pBidiLibC);

//int bidiLibCtrl(void *pBidiLibC, int idRequest, void *pData, int nDataBytes);

#endif // _BIDILIB_H
