/*
 *  OpenPrinting Vector Printer Driver for Canon Pixus850i
 *  Copyright (c) 2004 E&D Inc.
 *  All rights reserved.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * NOTE:
 *  - As a special exception, this program is permissible to link with the
 *    libraries released as the binary modules.
 *  - If you write modifications of your own for these programs, it is your
 *    choice whether to permit this exception to apply to your modifications.
 *    If you do not wish that, delete this exception.
*/

/* $Revision: 1.2 $ */

#include "bjp_cncldb.h"

short
bjp_GetCurrentnValue(LPCNCLDB	cncldb,
		     short	dbsize,
		     short	oid)
{
	LPCNCLDB	db = cncldb;
	short		i, ret = -1;

	for(i=0; i<dbsize; i++){
		if((db->nObjectID == oid) && (db->curset == 1)){
			ret = db->nValue;
			break;
		}
		db++;
	}
	return ret;
}

short
bjp_QueryValue(LPCNCLDB	lpdbTop,
	       short	dbsize,
	       short	id,
	       short	value)
{
	LPCNCLDB	lpdb = lpdbTop;
	short		ret = -1;
	short		i;

	lpdb = lpdbTop;
	for(i=0; i<dbsize; i++, lpdb++){
		if(lpdb->nObjectID == id){
			if((lpdb->nValue == value) && (lpdb->disable == 0)){
				ret = i;
				break;
			}
			if((lpdb+1)->nObjectID != lpdb->nObjectID)
				break;
		}
	}
	return ret;
}

short
bjp_SetTemporaryFlag(LPCNCLDB	lpdbTop,
		     short dbsize,
		     short id,
		     short value,
		     short flag)
{
	LPCNCLDB	lpdb = lpdbTop;
	short		ret = -1;
	short		i;

	lpdb = lpdbTop;
	for (i=0; i<dbsize; i++, lpdb++){
		if(lpdb->nObjectID == id){
			if(lpdb->nValue == value){
				lpdb->tmpset = flag;
				ret = i;
				break;
			}
			if((lpdb+1)->nObjectID != lpdb->nObjectID)
				break;
		}
	}
	return ret;
}
